$.level = 2;

const mm = 72/25.4


  markWeight = 0.25
  markLength = 5 *mm
  markOffset = 0 *mm

offsetStr = "Offset trim marx, bleed, color (c,m,y,k,r(registration))";
distribStr = "Distibute object?";
var regColor = new CMYKColor();
regColor.cyan = 100;
regColor.magenta = 0;
regColor.yellow = 0;
regColor.black = 0;

if ( documents.length > 0 )
{
	doc = activeDocument;
		
	
	origin = doc.rulerOrigin;
	var start = true;

if(of = prompt(offsetStr, "0 2 c")) {
			param = of.split(' ');
			bleedOffset = param[1] *mm 			
			markOffset = param[0] *mm;
			param[1] *= mm;
			if (param[2]=='c'){
				regColor.cyan = 100;
				regColor.magenta = 0;
				regColor.yellow = 0;
				regColor.black = 0;
			}
			if (param[2]=='m'){
				regColor.cyan = 0;
				regColor.magenta = 100;
				regColor.yellow = 0;
				regColor.black = 0;
			}
			if (param[2]=='y'){
				regColor.cyan = 0;
				regColor.magenta = 0;
				regColor.yellow = 100;
				regColor.black = 0;
			}
			if (param[2]=='k'){
				regColor.cyan = 0;
				regColor.magenta = 0;
				regColor.yellow = 0;
				regColor.black = 100;
			}
			if (param[2]=='r'){
				var regColor = new SpotColor();
				regColor.spot = doc.spots['[Registration]'];
			}			
		}
		else start = false;
	
	if(doc.selection instanceof Array && doc.selection.length==1) {
			B = param[1];		
			var obj = doc.selection[0];
			var obj1 = doc.selection;			
			var bnd = getBounds(obj1);
			W = bnd[2]-bnd[0];
			H = bnd[1]-bnd[3];
			xN = Math.floor(doc.width/W);
			yN = Math.floor(doc.height/H);
			
			if(confirm(distribStr)) {
				ox = ((doc.width-(W*xN))/2)-origin[0]+(obj.left - bnd[0]);
				oy = ((doc.height-(H*yN))/2)-origin[1]+(obj.top - bnd[1]);
				for(i=0; i<xN; i++) 
				for(j=1; j<=yN; j++) {
					objCopy = obj.duplicate(obj.parent);
					objCopy.left = ox+i*W;
					objCopy.top = oy+j*H;
				}
				obj.remove();
			}		
	}
	else 
		if(cmd = prompt(inputStr, "90:4 50:5 2")) {
			param = cmd.split(' ');
			B = param[2] *mm;
			tmp = param[0].split(':');
			W = tmp[0] *mm;
			xN = tmp[1];
			tmp = param[1].split(':');
			H = tmp[0] *mm;
			yN = tmp[1];
		
			W += B*2;
			H += B*2;		
		}
		else start = false;

	if(start) {
		var mLayer= doc.layers.add();
		mLayer.name = 'MarX';

		tW = W*xN;
		tH = H*yN;
		oX = ((doc.width-tW)/2)-origin[0];
		oY = ((doc.height-tH)/2)-origin[1];
	
		if(B>0) {
			for(i=0; i<xN; i++) {
				line(mLayer, oX+W*i+B, oY-markOffset, oX+W*i+B, oY-markOffset-markLength, regColor, markWeight);
				line(mLayer, oX+W*i+W-B, oY-markOffset, oX+W*i+W-B, oY-markOffset-markLength, regColor, markWeight);
				line(mLayer, oX+W*i+B, oY+tH+markOffset, oX+W*i+B, oY+tH+markOffset+markLength, regColor, markWeight);
				line(mLayer, oX+W*i+W-B, oY+tH+markOffset, oX+W*i+W-B, oY+tH+markOffset+markLength, regColor, markWeight);
			}
			for(i=0; i<yN; i++) {
				line(mLayer, oX-markOffset, oY+H*i+B, oX-markOffset-markLength, oY+H*i+B, regColor, markWeight);
				line(mLayer, oX-markOffset, oY+H*i+H-B, oX-markOffset-markLength, oY+H*i+H-B, regColor, markWeight);
				line(mLayer, oX+tW+markOffset, oY+H*i+B, oX+tW+markOffset+markLength, oY+H*i+B, regColor, markWeight);
				line(mLayer, oX+tW+markOffset, oY+H*i+H-B, oX+tW+markOffset+markLength, oY+H*i+H-B, regColor, markWeight);
			}
		}
		else {
			for(i=0; i<=xN; i++) {
				line(mLayer, oX+W*i, oY-markOffset, oX+W*i, oY-markOffset-markLength, regColor, markWeight);
				line(mLayer, oX+W*i, oY+tH+markOffset, oX+W*i, oY+tH+markOffset+markLength, regColor, markWeight);
			}
			for(i=0; i<=yN; i++) {
				line(mLayer, oX-markOffset, oY+H*i, oX-markOffset-markLength, oY+H*i, regColor, markWeight);
				line(mLayer, oX+tW+markOffset, oY+H*i, oX+tW+markOffset+markLength, oY+H*i, regColor, markWeight);
			}
		}
				
	}
}
else
{
	alert(norunStr);
}

function line(parent,x1,y1,x2,y2,color,weight) 
{
	var line = parent.pathItems.add();
	line.stroked = true;
	line.filled = false;
	line.strokeWidth = weight;
	line.strokeColor = color;
	line.setEntirePath( Array( Array(x1, y1), Array(x2, y2) ) );
	line = null;
}

function getBounds(obj) {	
	var vgb1 = new Array();
	var vgb2 = new Array();
	var n = obj.length;
	if (n>0){		
		if( (obj[0].typename == 'GroupItem') && obj[0].clipped && (obj[0].pageItems.length > 1) ) vgb1 = obj[0].pathItems[0].geometricBounds;
		else vgb1 = obj[0].geometricBounds;
		if (n > 1) {
			for (i=1; i<n; i++) {				
				if( (obj[i].typename == 'GroupItem') && obj[i].clipped && (obj[i].pageItems.length > 1) ) {
					vgb2 = obj[i].pathItems[0].geometricBounds;
				}		
				else {
					vgb2 = obj[i].geometricBounds;
				}
				if( vgb1[0] > vgb2[0] ) vgb1[0] = vgb2[0];
				if( vgb1[1] < vgb2[1] ) vgb1[1] = vgb2[1];
				if( vgb1[2] < vgb2[2] ) vgb1[2] = vgb2[2];
				if( vgb1[3] > vgb2[3] ) vgb1[3] = vgb2[3];
			}
		}
	}
	return vgb1;
}

